commit dc457bc1c72c53ee8c4800bac84264e0c8085f24
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Wed Apr 12 16:55:15 2023 +0200

    reassoc: Fix up another ICE with returns_twice call [PR109410]
    
    The following testcase ICEs in reassoc, unlike the last case I've fixed
    there here SSA_NAME_USED_IN_ABNORMAL_PHI is not the case anywhere.
    build_and_add_sum places new statements after the later appearing definition
    of an operand but if both operands are default defs or constants, we place
    statement at the start of the function.
    
    If the very first statement of a function is a call to returns_twice
    function, this doesn't work though, because that call has to be the first
    thing in its basic block, so the following patch splits the entry successor
    edge such that the new statements are added into a different block from the
    returns_twice call.
    
    I think we should in stage1 reconsider such placements, I think it
    unnecessarily enlarges the lifetime of the new lhs if its operand(s)
    are used more than once in the function.  Unless something sinks those
    again.  Would be nice to place it closer to the actual uses (or where
    they will be placed).
    
    2023-04-12  Jakub Jelinek  <jakub@redhat.com>
    
            PR tree-optimization/109410
            * tree-ssa-reassoc.c (build_and_add_sum): Split edge from entry
            block if first statement of the function is a call to returns_twice
            function.
    
            * gcc.dg/pr109410.c: New test.
    
    (cherry picked from commit 51856718a82ce60f067910d9037ca255645b37eb)

diff --git a/gcc/testsuite/gcc.dg/pr109410.c b/gcc/testsuite/gcc.dg/pr109410.c
new file mode 100644
index 00000000000..a6401fc100c
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr109410.c
@@ -0,0 +1,19 @@
+/* PR tree-optimization/109410 */
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+__attribute__((returns_twice)) int baz (int, int);
+
+int
+bar (int x)
+{
+  return x;
+}
+
+int
+foo (int x, int y)
+{
+  baz (x, y);
+  int a = bar (x);
+  return y || a == 42 || a > 42;
+}
diff --git a/gcc/tree-ssa-reassoc.c b/gcc/tree-ssa-reassoc.c
index 3a4d7e046c5..1a665928c13 100644
--- a/gcc/tree-ssa-reassoc.c
+++ b/gcc/tree-ssa-reassoc.c
@@ -1495,6 +1495,15 @@ build_and_add_sum (tree type, tree op1, tree op2, enum tree_code opcode)
       && (!op2def || gimple_nop_p (op2def)))
     {
       gsi = gsi_after_labels (single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)));
+      if (!gsi_end_p (gsi)
+	  && is_gimple_call (gsi_stmt (gsi))
+	  && (gimple_call_flags (gsi_stmt (gsi)) & ECF_RETURNS_TWICE))
+	{
+	  /* Don't add statements before a returns_twice call at the start
+	     of a function.  */
+	  split_edge (single_succ_edge (ENTRY_BLOCK_PTR_FOR_FN (cfun)));
+	  gsi = gsi_after_labels (single_succ (ENTRY_BLOCK_PTR_FOR_FN (cfun)));
+	}
       if (gsi_end_p (gsi))
 	{
 	  gimple_stmt_iterator gsi2

